#################################################################################################
## The polynomial approximation of the covariance term of Inverse normal 
## combination method in Section 2.2.2, Example 2
## Calculate the numerical integration by MATLAB code 'Matlab code Inverse normal
## numerical integration.m'
## v from 9 to 125, rho from -0.98 to 0.98
## R program written by Shiyang Ma at 2018-12-05, using R studio version: 3.5.0
#################################################################################################

rho_seq=seq(-0.98,0.98,by=0.02)
v_seq=seq(9,125,by=1)  
#Numerical integration of the covariance terms calculated using Matlab
N_cov_matlab=read.csv('Inverse normal numerical integration.csv',sep=',',header = FALSE)
N_cov_matlab=as.numeric(N_cov_matlab,options(digits =20))

rho_reg=rep(rho_seq, each = length(v_seq)) 
v_reg=rep(v_seq,length(rho_seq))
x1=rho_reg
x2=rho_reg^2
x3=rho_reg^3
x4=1/v_reg
x5=rho_reg/v_reg
x6=rho_reg^2/v_reg
x7=rho_reg^3/v_reg

# We try different covariates and finnally we decide to use x1, x3, x5, x7 and force 
# the coefficient of x1 to be 1, which is consistent as the known variance case.
# Then derive the polynominal approximation of the covariance term 
model=lm(N_cov_matlab-x1~x3+x5+x7-1)
summary(model)
round(model$coefficients,digit=5)
#Get the coefficients of x3, x5 and x7 are: 0.00019, -0.02378, 0.01891, repectively.
